SystemOrganization addCategory: #'SmalltalkQuiz-GUI'!
SystemOrganization addCategory: #SmalltalkQuiz!

Morph subclass: #ExamMorphSTQ
	instanceVariableNames: 'questionTextMoprh quiz choiceMorphs failedQuizs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz-GUI'!

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 14:12'!
addChoiceMorph

	|aMorph|
	choiceMorphs isNil ifTrue: 
	[
		choiceMorphs := OrderedCollection new.
	].
	
	aMorph := ChoiceMorphSTQ new.
	choiceMorphs addLast: aMorph.
	self addMorph: aMorph! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 14:12'!
addQuestionTextMorph

	questionTextMoprh := TextMorph new.
	questionTextMoprh color: Color white.
	self addMorph: questionTextMoprh! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2010 22:45'!
addSubmorphs

	self addQuestionTextMorph.
	self positionQuestionTextMorph.
	self setExtentOfQuestionTextMorph.
	self setContentsOfQuestionTextMorphWithQuiz.

	self addChoiceMorph.
	self  positionChoiceMorphAtIndex:1.
	self  setContentsOfChoiceMorphAtIndex:1.

	self  addChoiceMorph.
	self  positionChoiceMorphAtIndex:2.
	self  setContentsOfChoiceMorphAtIndex:2.

	self  addChoiceMorph.
	self  positionChoiceMorphAtIndex:3.
	self  setContentsOfChoiceMorphAtIndex:3.

	self  addChoiceMorph.
	self  positionChoiceMorphAtIndex:4.
	self  setContentsOfChoiceMorphAtIndex:4.
! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:50'!
beRounded

	self cornerStyle: #rounded! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/3/2010 10:03'!
choiceMorphAtIndex: aSmallInteger 

	^choiceMorphs at: aSmallInteger! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2010 22:42'!
choiceMorphHeight

	^30! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 11:36'!
extentOfQuestionTextMorph

	^questionTextMoprh extent - self widthInsetForSubmorphs! !

!ExamMorphSTQ methodsFor: 'geometry' stamp: 'hjo 5/1/2010 14:18'!
gapBetweenChoiceMorphs

	^3! !

!ExamMorphSTQ methodsFor: 'events-processing' stamp: 'hjo 5/1/2010 12:38'!
handleMouseDown: anEvent

	^true! !

!ExamMorphSTQ methodsFor: 'events-processing' stamp: 'hjo 5/1/2010 11:23'!
handleMouseUp: anEvent

	^true! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/3/2010 16:25'!
highlightCorrectChoiceMorphRight

	self unhighlightAllChoicesMorph.
	(choiceMorphs at: quiz indexOfCorrectChoice) color: Color green.! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/3/2010 16:26'!
highlightCorrectChoiceMorphWrong

	self unhighlightAllChoicesMorph.
	(choiceMorphs at: quiz indexOfCorrectChoice) color: Color red.! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 11:29'!
imposeRoundedCornerOnChoiceMorphAt: aSmallInteger 

	(choiceMorphs at: aSmallInteger) cornerStyle: #rounded! !

!ExamMorphSTQ methodsFor: 'initialization' stamp: 'hjo 5/14/2010 20:27'!
initialize

	super initialize.
	self setExtent.
	self beRounded.
	self setColor.
	self setRandomQuiz.
	self addSubmorphs.
	questionTextMoprh lock.
	self wireChoiceMorphs.
	self initializeFailedQuizs! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/14/2010 20:20'!
initializeFailedQuizs

	failedQuizs := OrderedCollection new! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 11:40'!
insetForSubmorphs

	^10! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 11:07'!
makeCurrentBezelsBeChoiceMorphs

	choiceMorphs := choiceMorphs collect: [:each| each owner]! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/14/2010 19:54'!
makeQuiz

	| quizClasses |
	quizClasses := {SubclassQuizSTQ . ClassThatUnderstandsMessageQuizSTQ . AntiSubclassQuizSTQ . CanUnderstandMessageSTQ . AntiCanUnderstandMessageSTQ. AntiClassThatUnderstandsMessageQuizSTQ}.

	^quizClasses atRandom randomInstance! !

!ExamMorphSTQ methodsFor: 'event handling' stamp: 'hjo 5/1/2010 12:39'!
mouseDown: evt

	self inform: 'down'.
	^super mouseUp: evt
! !

!ExamMorphSTQ methodsFor: 'event handling' stamp: 'hjo 5/1/2010 11:25'!
mouseUp: evt

	super mouseUp: evt.
	self inform: 'hi'! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/14/2010 20:26'!
onChoiceMadeByUser: aSmallInteger 

	(quiz rightOrWrongIfUserChoosed: aSmallInteger)
		ifTrue: [self highlightCorrectChoiceMorphRight. self inform: 'correct!!!!']
		ifFalse: [self highlightCorrectChoiceMorphWrong. failedQuizs addLast: quiz. self inform: 'wrong!!!!'].
	self setNextRandomQuiz! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 14:23'!
positionChoiceMorphAtIndex: aSmallInteger 

	| bezel |
	bezel := choiceMorphs at: aSmallInteger.
	bezel position: (self left+self insetForSubmorphs) @(self yPositionForChoiceIndex: aSmallInteger).
	"bezel submorphs do: [:each| each position: bezel position+(3@3)]"! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 11:18'!
positionChoiceMorphs

	1 to: choiceMorphs size do: [:k| self positionChoiceMorphAtIndex: k ]! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 11:39'!
positionQuestionTextMorph

	questionTextMoprh position: self widthInsetForSubmorphs @ 10 + self position! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 10:47'!
setBorderOfChoiceMorphs

	choiceMorphs do: [:each| each borderWidth: 2]! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:45'!
setColor

	self color: (Color r:0.1 g:0.4b:0.25 alpha:1)! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:46'!
setColorOfQuestionTextMorph

	questionTextMoprh textColor: Color white! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2010 23:57'!
setContents

	self setContentsOfQuestionTextMorphWithQuiz.
	self setContentsOfChoiceTextMorphsWithQuiz! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 11:44'!
setContentsOfChoiceMorphAtIndex: aSmallInteger 

	((choiceMorphs at:aSmallInteger) submorphs anyOne) contents: (quiz choiceStringAtIndex: aSmallInteger)! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2010 23:57'!
setContentsOfChoiceTextMorphsWithQuiz

	1 to: 4 do: [:k| self setContentsOfChoiceMorphAtIndex: k]! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/30/2010 00:00'!
setContentsOfQuestionTextMorphWithQuiz

	questionTextMoprh contentsWrapped: quiz questionString.
	questionTextMoprh wrapFlag: true! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:19'!
setExtent

	self extent: 299@236! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 11:42'!
setExtentChoiceMorphsAtIndex: aSmallInteger 

	(choiceMorphs at:aSmallInteger) extent: (self width - (self insetForSubmorphs*2)) @ self choiceMorphHeight! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 11:17'!
setExtentOfChoiceMorphs

	(1 to: choiceMorphs size) do: [:k| self setExtentChoiceMorphsAtIndex: k]! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 11:39'!
setExtentOfQuestionTextMorph

	questionTextMoprh extent: (self extent x - (self widthInsetForSubmorphs*2)) @ 100.
	questionTextMoprh wrapFlag: true.
! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/30/2010 00:19'!
setNextRandomQuiz

	self setRandomQuiz.
	self setContents.
	self unhighlightAllChoicesMorph.
! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2010 16:31'!
setRandomQuiz

	quiz := self makeQuiz! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/30/2010 00:28'!
setTextMorphColors

	questionTextMoprh color: Color white.
	choiceMorphs do: [:each| each color: Color white]! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 11:20'!
setTransparencyOfBezelOfChoiceMorphs
	
	choiceMorphs do: [:bezel| bezel color: (bezel color alpha: 0.2)]! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 11:35'!
unhighlightAllChoicesMorph

	choiceMorphs do: [:each| each color: (Color white alpha:0.2)]! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 10:55'!
unsetBorderOfChoiceMorphs

	choiceMorphs do: [:each| each borderWidth: 0]! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 11:40'!
widthInsetForSubmorphs

	^self insetForSubmorphs! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/3/2010 10:05'!
wireChoiceMorphAtIndex: aSmallInteger 

	(self choiceMorphAtIndex: aSmallInteger)
		target: self;
		actionSelector: #onChoiceMadeByUser: ;
		arguments: (Array with: aSmallInteger)! !

!ExamMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/3/2010 10:02'!
wireChoiceMorphs

	1 to: choiceMorphs size do: [ :k |
		self wireChoiceMorphAtIndex: k ]! !

!ExamMorphSTQ methodsFor: 'geometry' stamp: 'hjo 5/14/2010 20:19'!
yPositionForChoiceIndex: aSmallInteger 

	^questionTextMoprh bottom + 10 + (aSmallInteger * (self choiceMorphHeight+self gapBetweenChoiceMorphs))! !

SimpleButtonMorph subclass: #ChoiceMorphSTQ
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz-GUI'!

!ChoiceMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 14:07'!
initialize

	super initialize.
	self cornerStyle: #rounded.
	self borderWidth:0.
	self color: (Color white alpha:0.2).
	self extent: 278@32.
	self labelMorph color: Color white.
	self layoutSubmorphs
! !

!ChoiceMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 13:58'!
labelMorph

	self allMorphsDo: [:m | (m isKindOf: StringMorph) ifTrue: [^m]].
	self error: 'No label'! !

!ChoiceMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 14:01'!
layoutSubmorphs

	| labelOffset |
	labelOffset := (self extent - self labelMorph extent)/2.
	self labelMorph position: (self position x + 10) @ (self position + labelOffset) y! !

!ChoiceMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 14:15'!
lock

	super halt lock.! !

!ChoiceMorphSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/1/2010 14:21'!
updateVisualState: evt
	
	oldColor ifNotNil: [
		 self color: 
			((self containsPoint: evt cursorPoint)
				ifTrue: [(oldColor mixed: 0.6 with: Color black) alpha:0.2]
				ifFalse: [oldColor])]
! !

Object subclass: #QuizSTQ
	instanceVariableNames: 'choices subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

QuizSTQ subclass: #AntiCanUnderstandMessageSTQ
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!AntiCanUnderstandMessageSTQ classSide methodsFor: 'as yet unclassified' stamp: 'hjo 5/7/2010 21:27'!
allExistingSelectors

	^(CompiledMethod allInstances collect:[:each| each selector]) asSet! !

!AntiCanUnderstandMessageSTQ classSide methodsFor: 'as yet unclassified' stamp: 'hjo 5/14/2010 19:06'!
randomInstance

	| allSelectors distinguishedSelectors theClass choices instance |
	theClass := Smalltalk allClasses atRandom.
	
	allSelectors := self allExistingSelectors.
	distinguishedSelectors := allSelectors distinguishedBy: [:each| (theClass canUnderstand: each) not ].
	choices := Set new.
	choices add: distinguishedSelectors selectedOnes atRandom.
	[choices add: distinguishedSelectors rejectedOnes atRandom.
		choices size < 4 ] whileTrue.
	choices := choices asArray shuffled.

	instance := self new.
	instance theClass: theClass.
	instance choices: choices.
	^instance! !

!AntiCanUnderstandMessageSTQ methodsFor: 'testing' stamp: 'hjo 5/7/2010 21:28'!
isChoiceCorrect: anObject

	^(subject canUnderstand: anObject) not! !

!AntiCanUnderstandMessageSTQ methodsFor: 'printing' stamp: 'hjo 5/7/2010 21:27'!
questionString

	^'Which one of the messages below cannot be understood by ', subject printString , '?'! !

!AntiCanUnderstandMessageSTQ methodsFor: 'accessing' stamp: 'hjo 5/7/2010 21:27'!
theClass: aClass 

	subject := aClass! !

QuizSTQ subclass: #AntiClassThatUnderstandsMessageQuizSTQ
	instanceVariableNames: 'theSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!AntiClassThatUnderstandsMessageQuizSTQ classSide methodsFor: 'as yet unclassified' stamp: 'hjo 5/14/2010 20:02'!
randomInstance

	^self new beRandom! !

!AntiClassThatUnderstandsMessageQuizSTQ methodsFor: 'operations' stamp: 'hjo 5/14/2010 20:03'!
beRandom

	| distinguishment choiceSet |
	
	[	theSelector := CompiledMethod allInstances atRandom selector.
		distinguishment := Smalltalk allClasses distinguishedBy: [:each| (each canUnderstand: 	theSelector) not ].
		distinguishment selectedOnes size>=1 and: [distinguishment rejectedOnes size>=3]
	] whileFalse.

	choiceSet := Set new.
	choiceSet add: distinguishment selectedOnes atRandom.
	[choiceSet size < 4] whileTrue:
		[choiceSet add: distinguishment rejectedOnes atRandom] .

	choices := choiceSet asArray shuffled! !

!AntiClassThatUnderstandsMessageQuizSTQ methodsFor: 'testing' stamp: 'hjo 5/14/2010 19:56'!
isChoiceCorrect: anObject

	^(anObject canUnderstand: theSelector) not! !

!AntiClassThatUnderstandsMessageQuizSTQ methodsFor: 'printing' stamp: 'hjo 5/14/2010 19:55'!
questionString

	^'Which one of classes below cannot understand message #', theSelector  , '?'! !

QuizSTQ subclass: #AntiSubclassQuizSTQ
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!AntiSubclassQuizSTQ classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 12:58'!
randomInstance

	^self new beRandom! !

!AntiSubclassQuizSTQ methodsFor: 'operations' stamp: 'hjo 4/8/2010 18:02'!
beRandom

	| allclasses class choice exchoice |
	allclasses := Smalltalk allClasses.

	allclasses atRandom.
	[class := allclasses atRandom.
	class allSubclasses size < 3 ] whileTrue.

	choice := Set new. 
	[choice add:(class allSubclasses atRandom).
	choice size = 3 ]whileFalse.

	[exchoice := allclasses atRandom.
	class ~= exchoice and: [(class inheritsFrom:exchoice) not].]whileFalse.

	choice add:exchoice.


	self choices: choice asArray shuffled.
	self theClass: class.! !

!AntiSubclassQuizSTQ methodsFor: 'testing' stamp: 'hjo 5/3/2010 19:50'!
isChoiceCorrect: anObject

	^(anObject inheritsFrom: self theClass) not! !

!AntiSubclassQuizSTQ methodsFor: 'printing' stamp: 'hjo 5/3/2010 15:19'!
questionString

	^'Which one of the classes below is not subclass of ', subject asString , '?'! !

!AntiSubclassQuizSTQ methodsFor: 'accessing' stamp: 'hjo 5/3/2010 15:20'!
theClass

	^subject! !

!AntiSubclassQuizSTQ methodsFor: 'accessing' stamp: 'hjo 5/3/2010 15:19'!
theClass: aClass 

	subject := aClass! !

QuizSTQ subclass: #CanUnderstandMessageSTQ
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!CanUnderstandMessageSTQ classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 12:53'!
allExistingSelectors

	^(CompiledMethod allInstances collect:[:each| each selector]) asSet! !

!CanUnderstandMessageSTQ classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 12:53'!
randomInstance

	| allSelectors distinguishedSelectors theClass choices instance |
	theClass := Smalltalk allClasses atRandom.
	
	allSelectors := self allExistingSelectors.
	distinguishedSelectors := allSelectors distinguishedBy: [:each| theClass canUnderstand: each].
	choices := Set new.
	choices add: distinguishedSelectors selectedOnes atRandom.
	[choices add: distinguishedSelectors rejectedOnes atRandom.
		choices size < 4 ] whileTrue.
	choices := choices asArray shuffled.

	instance := self new.
	instance theClass: theClass.
	instance choices: choices.
	^instance! !

!CanUnderstandMessageSTQ methodsFor: 'testing' stamp: 'hjo 5/3/2010 19:51'!
isChoiceCorrect: anObject

	^subject canUnderstand: anObject! !

!CanUnderstandMessageSTQ methodsFor: 'printing' stamp: 'hjo 5/3/2010 15:22'!
questionString

	^'Which one of the messages below can be understood by ', subject printString , '?'! !

!CanUnderstandMessageSTQ methodsFor: 'accessing' stamp: 'hjo 5/3/2010 15:22'!
theClass: aClass 

	subject := aClass! !

QuizSTQ subclass: #ClassThatUnderstandsMessageQuizSTQ
	instanceVariableNames: 'theSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!ClassThatUnderstandsMessageQuizSTQ classSide methodsFor: 'as yet unclassified' stamp: 'hjo 5/14/2010 20:02'!
randomInstance

	^self new beRandom! !

!ClassThatUnderstandsMessageQuizSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 5/14/2010 20:06'!
beRandom

	| distinguishment choiceSet |
	

	[	theSelector := CompiledMethod allInstances atRandom selector.
		distinguishment := Smalltalk allClasses distinguishedBy: [:each| each canUnderstand: 	theSelector ].
		distinguishment selectedOnes size>=1 and: [distinguishment rejectedOnes size>=3]
	] whileFalse.

	choiceSet := Set new.
	choiceSet add: distinguishment selectedOnes atRandom.
	[choiceSet size < 4] whileTrue:
		[choiceSet add: distinguishment rejectedOnes atRandom] .

	choices := choiceSet asArray shuffled! !

!ClassThatUnderstandsMessageQuizSTQ methodsFor: 'testing' stamp: 'hjo 5/3/2010 19:52'!
isChoiceCorrect: anObject

	^anObject canUnderstand: theSelector! !

!ClassThatUnderstandsMessageQuizSTQ methodsFor: 'printing' stamp: 'hjo 4/8/2010 18:53'!
questionString

	^'Which one of classes below can understand message #', theSelector  , '?'! !

!ClassThatUnderstandsMessageQuizSTQ methodsFor: 'operations' stamp: 'hjo 5/14/2010 20:03'!
randomInstance

	| distinguishment choiceSet |
	

	[	theSelector := CompiledMethod allInstances atRandom selector.
		distinguishment := Smalltalk allClasses distinguishedBy: [:each| each canUnderstand: 	theSelector ].
		distinguishment selectedOnes size>=1 and: [distinguishment rejectedOnes size>=3]
	] whileFalse.

	choiceSet := Set new.
	choiceSet add: distinguishment selectedOnes atRandom.
	[choiceSet size < 4] whileTrue:
		[choiceSet add: distinguishment rejectedOnes atRandom] .

	choices := choiceSet asArray shuffled! !

!QuizSTQ classSide methodsFor: 'as yet unclassified' stamp: 'hjo 5/3/2010 13:51'!
randomInstance

	^self subclassResponsibility! !

!QuizSTQ methodsFor: 'printing' stamp: 'hjo 5/3/2010 14:32'!
choiceStringAtIndex: aSmallInteger 

	^' (', aSmallInteger printString , ') ' , (self choices at: aSmallInteger) asString! !

!QuizSTQ methodsFor: 'accessing' stamp: 'hjo 5/3/2010 19:29'!
choices

	^choices! !

!QuizSTQ methodsFor: 'accessing' stamp: 'hjo 5/3/2010 19:31'!
choices: aSet 
	
	choices := aSet! !

!QuizSTQ methodsFor: 'printing' stamp: 'hjo 5/3/2010 19:35'!
choicesString

	^'  (1)  ' , (self choices at:1) asString, String cr,
	'  (2)  ' , (self choices at:2) asString, String cr,
	'  (3)  ' , (self choices at:3) asString, String cr,
	'  (4)  ' , (self choices at:4) asString, String cr
! !

!QuizSTQ methodsFor: 'searching' stamp: 'hjo 5/3/2010 19:48'!
correctChoice

	| corrects |
	corrects := self choices select: [:each | self isChoiceCorrect: each].
	self assert: [corrects size = 1] description: 'Only one choice must be correct.'.
	^corrects anyOne! !

!QuizSTQ methodsFor: 'searching' stamp: 'hjo 5/3/2010 11:12'!
indexOfCorrectChoice

	^self choices indexOf: self correctChoice! !

!QuizSTQ methodsFor: 'testing' stamp: 'hjo 5/3/2010 19:49'!
isChoiceCorrect: anObject

	^self subclassResponsibility! !

!QuizSTQ methodsFor: 'printing' stamp: 'hjo 5/3/2010 19:38'!
questionAndChoicesString

	^self questionString, String cr, self choicesString.! !

!QuizSTQ methodsFor: 'printing' stamp: 'hjo 5/3/2010 13:52'!
questionString

	^self subclassResponsibility! !

!QuizSTQ methodsFor: 'testing' stamp: 'hjo 5/3/2010 11:11'!
rightOrWrongIfUserChoosed: aSmallInteger 

	^self indexOfCorrectChoice = aSmallInteger! !

!QuizSTQ methodsFor: 'accessing' stamp: 'hjo 5/3/2010 19:34'!
subject
	"Answer the value of subject"

	^ subject! !

!QuizSTQ methodsFor: 'accessing' stamp: 'hjo 5/3/2010 19:34'!
subject: anObject
	"Set the value of subject"

	subject := anObject! !

QuizSTQ subclass: #SubclassQuizMakerSTQ
	instanceVariableNames: 'allClasses theClass subclassesOfTheClass separatedGroups unshuffledChoices shuffledChoices quiz'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 09:59'!
doJob

	self selectRandomClassThatHasAtLeastOneSubclass.
	self separateClassesIntoTwoGrouopsOneWithSubclassOfItOthersWithNotSubclassesOfIt.
	self selectRandomOneClassFromSubclassGroupPutItIntoChoices.
	self selectThreeRandomClassesFromNonSubclassGroupPutItIntoChoices.
	self shuffleTheChoices.
	^self makeQuiz! !

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 13:14'!
doJobInlined

	[allClasses := Smalltalk allClasses.
	theClass := allClasses atRandom.
	subclassesOfTheClass := theClass allSubclasses.
	subclassesOfTheClass size > 0] whileFalse.

	separatedGroups := allClasses distinguishedBy: [:each| each inheritsFrom: theClass ].
	unshuffledChoices := Set with: separatedGroups selectedOnes atRandom.
	[unshuffledChoices add: separatedGroups rejectedOnes atRandom.
	unshuffledChoices size < 4] whileTrue.

	shuffledChoices := unshuffledChoices asArray shuffled.
	quiz := SubclassQuizSTQ new.
	quiz theClass: theClass.
	quiz choices: shuffledChoices.
	^quiz! !

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 13:14'!
makeQuiz

	quiz := SubclassQuizSTQ new.
	quiz theClass: theClass.
	^quiz choices: shuffledChoices! !

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 09:50'!
selectRandomClassThatHasAtLeastOneSubclass

	[allClasses := Smalltalk allClasses.
	theClass := allClasses atRandom.
	subclassesOfTheClass := theClass allSubclasses.
	subclassesOfTheClass size > 0] whileFalse! !

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 09:53'!
selectRandomOneClassFromSubclassGroupPutItIntoChoices

	unshuffledChoices := Set with: separatedGroups selectedOnes atRandom! !

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 09:54'!
selectThreeRandomClassesFromNonSubclassGroupPutItIntoChoices

	[unshuffledChoices add: separatedGroups rejectedOnes atRandom.
	unshuffledChoices size < 4] whileTrue! !

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 09:52'!
separateClassesIntoTwoGrouopsOneWithSubclassOfItOthersWithNotSubclassesOfIt

	separatedGroups := allClasses distinguishedBy: [:each| each inheritsFrom: theClass ]! !

!SubclassQuizMakerSTQ methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2010 09:55'!
shuffleTheChoices

	shuffledChoices := unshuffledChoices asArray shuffled! !

QuizSTQ subclass: #SubclassQuizSTQ
	instanceVariableNames: 'answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!SubclassQuizSTQ classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2010 12:38'!
randomInstance

	| allClasses theClass subclassesOfTheClass separatedGroups unshuffledChoices shuffledChoices quiz |
	[allClasses := Smalltalk allClasses.
	theClass := allClasses atRandom.
	subclassesOfTheClass := theClass allSubclasses.
	subclassesOfTheClass size > 0] whileFalse.

	separatedGroups := allClasses distinguishedBy: [:each| each inheritsFrom: theClass ].
	unshuffledChoices := Set with: separatedGroups selectedOnes atRandom.
	[unshuffledChoices add: separatedGroups rejectedOnes atRandom.
	unshuffledChoices size < 4] whileTrue.

	shuffledChoices := unshuffledChoices asArray shuffled.
	quiz := self new.
	quiz theClass: theClass.
	quiz choices: shuffledChoices.
	^quiz! !

!SubclassQuizSTQ methodsFor: 'testing' stamp: 'hjo 5/3/2010 19:51'!
isChoiceCorrect: anObject

	^anObject inheritsFrom: self theClass! !

!SubclassQuizSTQ methodsFor: 'printing' stamp: 'hjo 5/3/2010 15:24'!
questionString

	^'Which one of the classes below is subclass of ', subject asString , '?'! !

!SubclassQuizSTQ methodsFor: 'accessing' stamp: 'hjo 5/3/2010 15:23'!
theClass

	^subject! !

!SubclassQuizSTQ methodsFor: 'accessing' stamp: 'hjo 5/3/2010 15:24'!
theClass: aClass 

	subject := aClass! !
